; << Курсовой проект по дисциплине "Системы компьютерной графики" >>
; Выполнил студент группы ИТ-22
; Храбров Дмитрий a.k.a. DeXPeriX
; ICQ: 606986
; E-mail: dexperix[Ha]mail.ru
; Jabber: dexperix@jabber.ru
; Беларусь, Гомель, ГГТУ им. П. О. Сухого, 2007г.


;Функция отвечает непосредственно за рисование детали на чертеже
;соответствует 8 блоку графической схемы
(defun DrawDetail (d1 d2 d3 bd2 bd3 h bh tt b e n nformat / ee)
  ;"настройка" AutoCAD перед началом выполнения
  (command "_.erase" "_all" "")
  (command "_.osnap" "_none")
  (setvar "DIMPOST" "")
  ;параметр для выноски размеров и смещения 2 детали 
  (setq ee 4)
  ;основной контур. по часовой стрелке
  (setq 
        p1 (list 0 (- (/ d3 2) e) )
        p2 (list (- h e) (NTH 1 p1) )
        p3 (list (+ (NTH 0 p2) e) (/ bd2 2) ) 
        p4 (list (- bh b) (NTH 1 p3) ) 
        p5 (list (NTH 0 p4) (+ (NTH 1 p4) tt) ) 
        p6 (list bh (NTH 1 p5) )
        p7 (list (NTH 0 p6) (- (NTH 1 p6) ) )
	p8 (list (NTH 0 p5) (- (NTH 1 p5) ) )
	p9 (list (NTH 0 p4) (- (NTH 1 p4) ) )
	p10 (list (NTH 0 p3) (- (NTH 1 p3) ) )
	p11 (list (NTH 0 p10) (- (+ (/ d3 2) (/ e 2) ) ) )
	p12 (list (NTH 0 p1)  (NTH 1 p11) )
  )
  ;дополнительные контуры
  (setq
        tp4 (list bh (NTH 1 p4) )
	tp9 (list bh (NTH 1 p9) )
  )
  (setq
        dp1 (list 0 (- (/ d1 2) e) ) 
        dp2 (list (+ h b) (NTH 1 dp1) )
  	dp3 (list (NTH 0 dp2) (- (+ (/ d1 2) e) ) )
        dp4 (list (NTH 0 dp1) (NTH 1 dp3) )
	dp5 (list h (NTH 1 dp3) )
  )
  (setq
        dl1 (list (NTH 0 dp2) ( - (/ d2 2) e) )
	dl2 (list (NTH 0 p6) (NTH 1 dl1) )
	dl3 (list (NTH 0 dl2) (- (+ (/ d2 2) e) ) )
	dl4 (list (NTH 0 dl1) (NTH 1 dl3) )
  )
  ;данные для штриховки
  (setq
	sh1 (list (NTH 0 dp2) (+ (NTH 1 dp2)
              (/ (- (NTH 1 p4) (NTH 1 dp2) ) 2)) )
	sh2 (list (NTH 0 dp3) (+ (NTH 1 dp3)
              (/ (- (NTH 1 p9) (NTH 1 dp3) ) 2)) )
	mashtab (/ (+ bd3 bh) 100.0)
	ugol "0"
  )
  ;данные для 2 проекции
  (setq
    cent1 (list (+ bh (* 7 ee) (* 3 e) (/ bd3 2) ) 0 )
	cent2 (list (NTH 0 cent1) (- e) )
  )
  ;данные для осей 2 проекции
  (setq
    os11 (list (- (NTH 0 cent1) (/ bd3 2) (* 2 e) ) 0 )
	os12 (list (+ (NTH 0 cent1) (/ bd3 2) (* 4 e) ) 0 )
	os21 (list (+ (NTH 0 os11) e) (- e) )
	os22 (list (- (NTH 0 os12) e) (- e) )
	os31 (list (NTH 0 cent1) (+ (/ bd3 2) ee) )
	os32 (list (NTH 0 os31) (- (NTH 1 os31) ) )
  )
  ;данные для вынесения размеров 2 проекции
  (setq
        dr11 (list (- (NTH 0 os12) (* 2 e) ) 0 )
	dr12 (list (NTH 0 dr11) (- e) )
	dr1r (list (NTH 0 dr11) 0)
	dr21 (list (- (NTH 0 os31) (/ n 2) ) (/ bd3 2) )
	dr22 (list (+ (NTH 0 os31) (/ n 2) ) (/ bd3 2) )
	dr2r (list (NTH 0 dr21) (+ (/ bd3 2) (* 2 e) ) )
  )
  ;непосредственно рисование
  (command "_.layer" "_s" "Основной" "")
  (command "_.linetype" "_s" "CONTINUOUS"  "")
  (command "_.pline" p1 p2 p3 p4 p5 p6 
                     p7 p8 p9 p10 p11 p12 "_c")
  (command "_.pline" dp1 dp2 dp3 dp4 "")
  (command "_.line" dl1 dl2 "")
  (command "_.line" dl3 dl4 "")
  (command "_.line" p4 tp4 "")
  (command "_.line" p9 tp9 "")
  ;непосредственное рисование 2 проекции
  (command "_.circle" cent1 (/ bd2 2))
  (setq bd2name (entlast) )
  (command "_.circle" cent1 (/ bd3 2))
  (setq bd3name (entlast) )
  (command "_.circle" cent2 (/ d1 2))
  (command "_.circle" cent2 (/ d2 2))
  (command "_.circle" cent2 (/ d3 2))

  (command "_.line" (list (- (NTH 0 os31) (/ n 2) )
                          (+ (NTH 1 os31) ee) ) 
                    (list (- (NTH 0 os32) (/ n 2) )
                          (- (NTH 1 os32) ee) )"")
  (setq l1name (entlast) )
  (command "_.line" (list (+ (NTH 0 os31) (/ n 2) ) 
                          (+ (NTH 1 os31) ee) ) 
                    (list (+ (NTH 0 os32) (/ n 2) )
                          (- (NTH 1 os32) ee) )"")
  (setq l2name (entlast) )
  
  (command "_.trim" l1name l2name ""
    (list (NTH 0 os31) (- (/ bd3 2) ) ) "")
  
  (command "_.trim" bd2name bd3name "" 
    (list  (- (NTH 0 os31) (/ n 2) )
           (+ (/ bd3 2) ee) ) "")
  (command "_.trim" bd2name bd3name "" 
    (list  (- (NTH 0 os31) (/ n 2) )
           (- (+ (/ bd3 2) ee) ) ) "")
  (command "_.trim" bd2name bd3name ""
    (list  (- (NTH 0 os31) (/ n 2) )
           (/ bd2 4) ) "")

  (command "_.trim" bd2name bd3name ""
    (list  (+ (NTH 0 os31) (/ n 2) )
           (+ (/ bd3 2) ee) ) "")
  (command "_.trim" bd2name bd3name "" 
    (list  (+ (NTH 0 os31) (/ n 2) ) 
           (- (+ (/ bd3 2) ee) ) ) "")
  (command "_.trim" bd2name bd3name "" 
    (list  (+ (NTH 0 os31) (/ n 2) ) 
           (/ bd2 4) ) "")

  (command "_.trim" l1name l2name "" 
    (list (NTH 0 os31) (/ bd3 2) ) "")
  


  ;штриховка
  (command "_.layer" "_s" "Штриховка" "")
  (command "_.bhatch" "с" "ansi31" mashtab ugol sh1 "")
  (command "_.bhatch" "с" "ansi31" mashtab ugol sh2 "")
  ;дополнительные линии
  (command "_.linetype" "_s" "НЕВИДИМАЯ2"  "")
  (command "_.layer" "_s" "Основной" "")
  (command "_.line" p4 p9 "")
  (command "_.line" dp5 p3 "")
  (command "_.line" dp5 p2 "")
  ;оси
  (command "_.layer" "_s" "Оси" "")
  (command "_.linetype" "_s" "ОСЕВАЯ2"  "")
  (command "_.line" (list (- ee) 0) (list (+ bh ee) 0) "")
  (command "_.line" (list (- (* 0.5 ee)) (- ee) )
                    (list (+ bh (* 1.5 ee) ) (- ee)) "")
  ;оси для 2 проекции
  (command "_.line" os11 os12 "")
  (command "_.line" os21 os22 "")
  (command "_.line" os31 os32 "")
  (command "_.linetype" "_s" "CONTINUOUS"  "")
  ;простановка размеров
  (command "_.layer" "_s" "Размеры" "")
    ;горизонтальные основной проекции
  (command "_.dimlinear" p6 tp4 (list (+ (* 2.5 ee) bh) 0) )

    ;вертикальные основной проекции
  (command "_.dimlinear" p12 p10 (list 0 (- (- (/ bd2 2) )
                                          (* 4 ee) ) ) )
  (command "_.dimlinear" p12 p7 (list 0 (- (- (/ bd3 2) )
                                           (* 5 ee) ) ) )
  (command "_.dimlinear" p8 p7 (list 0 (- (- (/ bd3 2) )
                                          (* 2 ee) ) ) )
    ;дополнительной проекции
  (command "_.dimlinear" dr11 dr12 dr1r)
  (command "_.dimlinear" dr21 dr22 dr2r)

    ;Простановка диаматров
      ;задание приставки к размерам в виде знака диаметра
      (setvar "DIMPOST" "%%C<>")
  (command "_.dimlinear" dp1 dp4 (list (- (* 2 ee) ) 0) )
  (command "_.dimlinear" p1 p12 (list (- (* 4 ee) ) 0) )
  (command "_.dimlinear" p3 p10 (list (- (* 6 ee) ) 0) )
  (command "_.dimlinear" dl2 dl3 (list (+ (* 5 ee) bh) 0) )
  (command "_.dimlinear" p6 p7 (list (+ (* 7 ee) bh) 0) )

    ;Все, кроме рамки нарисовано. Запоминаем примитивы, чтобы потом
    ;можно было выполнить над ним "масштаб" и "повернуть"
  (setq PucyHoK (SSGEt "X") )
  
    ;рамка
  (command "_.ATTDIA" "1")
  ;рассчитываю точки вставки
  (setq A4x (+ (- -105 (* 5 ee) ) (/ (NTH 0 os12) 2) ) )
  (setq A3x (+ (- -210 (* 5 ee) ) (/ (NTH 0 os12) 2) ) )
  (setq A2x (+ (- -320 (* 5 ee) ) (/ (NTH 0 os12) 2) ) )
  (setq A1x (+ (- -420 (* 5 ee) ) (/ (NTH 0 os12) 2) ) )
  ;непосредственное рисование рамок
  (if(= nformat "radio1")  (command "_.insert" "A4" 
                                (list A4x -180) 1 1 0) )
  (if(= nformat "radio2")  (command "_.insert" "A3" 
                                (list A3x -180) 1 1 0) )
  (if(= nformat "radio3")  (command "_.insert" "A2"
                                (list A2x -210) 1 1 0) )
  (if(= nformat "radio4")  (command "_.insert" "A1" 
                                (list A1x -360) 1 1 0) )

  ;Выполнение дополнительных действий над объектом. 
  ;Соответствует 9 блоку графической схемы
  
  ;Action

  (setq doac "")


( WHILE (AND (/= doac "f") (/= doac "F") )
  
  ( SETQ doac ( GETSTRING "\nИзменить: 
Mасштаб (S), Повернуть (R), Переместить (M), Завершить (F): " ) )
 

  (if ( OR ( = doac "м" ) ( = doac "М" ) 
           ( = doac "s" ) ( = doac "S" ) )
   (progn
    (setq s_scale (GETREAL "\n Масштаб: ") )
    ;(command "_.DIMSCALE" (s_scale) )
    (command "_.DIMSCALE" 1)
    (command "_.scale" PucyHoK "" "0,0" s_scale "")
    (command "_.DIMLFAC" (/ 1  s_scale) )
   )
  )

  (if ( OR ( = doac "п" ) ( = doac "П" ) 
           ( = doac "r" ) ( = doac "R" ) )
   (progn
    (setq r_point (GETPOINT "\n Базовая точка: ") )
    ;(setq r_angle (GETREAL "\n Угол: ") )
    ;(command "_.rotate" PucyHoK "" r_point r_angle "")
    (command "_.rotate" PucyHoK "" r_point pause)
   )
  )


  (if ( OR ( = doac "m" ) ( = doac "M" ) )
     (command "_.move" PucyHoK "" "0,0" pause)
  )

)

)
  
;Основная функция запуска программы без диалога
;(для тестирования рисования)
(defun RunDraw ()
  (DrawDetail 56 50 62 72 90 16 58 10 10 5 8 0)
)

;Установка остальных полей по 1
(defun set_fields(val / d1 d2 d3 bd2 bd3 h bh tt b e n)
  (setq d1 (atof val) )
  (setq d2 (* d1 0.89) )
  (setq d3 (* d1 1.14) )
  (setq bd2 (* d1 1.27) )
  (setq bd3 (* d1 1.6) )
  (setq h (* d1 0.3) )
  (setq bh (* d1 1.01) )
  (setq tt (* d1 0.16) )
  (setq b (* d1 0.18) )
  (setq e (* d1 0.07) )
  (setq n (* d1 0.125) )
  (setq d2 (rtos d2) )
  (setq on_d2 d2)
  (setq d3 (rtos d3) )
  (setq on_d3 d3)
  (setq bd2 (rtos bd2) )
  (setq on_bd2 bd2)
  (setq bd3 (rtos bd3) )
  (setq on_bd3 bd3)
  (setq h (rtos h) )
  (setq on_h h)
  (setq bh (rtos bh) )
  (setq on_bh bh)
  (setq tt (rtos tt) )
  (setq on_tt tt)
  (setq b (rtos b) )
  (setq on_b b)
  (setq e (rtos e) )
  (setq on_e e)
  (setq n (rtos n) )
  (setq on_n n)
  ;установление значений в поля формы
  (set_tile "d2edit" d2)
  (set_tile "d3edit" d3)
  (set_tile "bd2edit" bd2)
  (set_tile "bd3edit" bd3)
  (set_tile "hedit" h)
  (set_tile "bhedit" bh)
  (set_tile "ttedit" tt)
  (set_tile "bedit" b)
  (set_tile "eedit" e)
  (set_tile "nedit" n)
)

;Функция, выполняющаяся по нажатию кнопки "ОК" в основном диалоге
  (defun ok_tab ( / )    
    (setq d1 (atof on_d1)
	  d2 (atof on_d2)
	  d3 (atof on_d3)
	  bd2 (atof on_bd2)
	  bd3 (atof on_bd3)
	  h (atof on_h)
	  bh (atof on_bh)
	  tt (atof on_tt)
	  b (atof on_b)
	  e (atof on_e)
	  n (atof on_n)
    )
  )

;Функция выбора формата листа
;соответствует 4 блоку графической схемы
(defun dd_radio ( / ret_value1 dcl_id what_next on_rad)
; функция, вызываемая по OK (формирование списка данных на выход)
  (defun ok_radio_tab ( / )
    (setq ret_value1 on_rad)
  )
; загрузка файла-диалога
  (setq dcl_id (load_dialog "pamka.dcl"))
; проверка существования диалога, если не существует - возвращаем
; заведомо неправильное значение. 
; Тогда рамка не будет рисоваться вообще
  (if (not (new_dialog "dd_radio" dcl_id)) (exit) 
   (progn
; начальные установки переменных и элементов
  (set_tile "radio1" "1")
  (setq on_rad "radio1")
  (setq what_next 8)
; цикл
  (while (< 2 what_next)
    (action_tile "radio1" "(setq on_rad $key)")
    (action_tile "radio2" "(setq on_rad $key)") 
    (action_tile "radio3" "(setq on_rad $key)")
    (action_tile "radio4" "(setq on_rad $key)") 
    (action_tile "accept" "(done_dialog 1) (ok_radio_tab)")
    (action_tile "cancel" "(done_dialog 1) (exit)")
    (setq what_next (start_dialog))
  )
; выгрузка диалога из памяти
  (unload_dialog dcl_id) ; Unload the DCL file
  ret_value1
   )
  )
) 


;Функция запуска визуального диалога. Она же основная
(defun run_dialog ( / ret_value1 dcl_id1 what_next on_ed2 on_ed1)
; начало программы (блок 1)
  ( SETQ flag T ) ; блок 2 графической схемы
( WHILE flag ; блок 3 графической схемы
    ; узнаём формат листа
  (setq f_format (dd_radio) ) ;блок 4 графической схемы
    ; загрузка основного диалога
  (setq dcl_id1 (load_dialog "form.dcl"))
  ; проверка существования диалога, если не существует - выход
  (if (not (new_dialog "dd_param" dcl_id1))(exit))
  ; начальные установки переменных и элементов
  (set_tile "d1edit" "")
  (set_tile "d2edit" "")
  (set_tile "d3edit" "")
  (set_tile "bd2edit" "")
  (set_tile "bd3edit" "")
  (set_tile "hedit" "")
  (set_tile "bhedit" "")
  (set_tile "ttedit" "")
  (set_tile "bedit7" "")
  (set_tile "eedit" "")
  (set_tile "nedit" "")
  (setq on_d1 ""
	on_d2 ""
	on_d3 ""
	on_bd2 ""
	on_bd3 ""
	on_h ""
	on_bh ""
	on_tt ""
	on_b ""
	on_e ""
	on_n ""
	)
( SETQ flag1 T )
  ( WHILE flag1 

  (start_image "ff")
  (slide_image 0 0  (dimx_tile "ff") (dimy_tile "ff")  "screenshot" )
  (end_image)
  (setq what_next 8)
  ; цикл для обработки ввода данных пользователем. 
  ; Соответствует 5 блоку графической схемы
  (while (< 2 what_next)
    ;дух машины, мой бубен сильнее твоей тупости!!!
    (action_tile "d1edit" "(setq on_d1 $value)(set_fields $value)")
    (action_tile "d2edit" "(setq on_d2 $value)")
    (action_tile "d3edit" "(setq on_d3 $value)")
	(action_tile "bd2edit" "(setq on_bd2 $value)")
	(action_tile "bd3edit" "(setq on_bd3 $value)")
    (action_tile "hedit" "(setq on_h $value)")
    (action_tile "bhedit" "(setq on_bh $value)")
    (action_tile "bedit" "(setq on_b $value)")
    (action_tile "ttedit" "(setq on_tt $value)")
    (action_tile "eedit" "(setq on_e $value)")
    (action_tile "nedit" "(setq on_n $value)")
    (action_tile "accept" "(done_dialog 1) (ok_tab)")
	(action_tile "cancel" "(done_dialog 1) (exit)")
    (setq what_next (start_dialog))
  )

; Проверка введённых данных. Соответствует 6 блоку графической схемы
(if ( or ( <= bd2 d3)  ( <= d3 d1 )  ( <= bh h) (< d1 1) )

(progn
  ;Параметры заданы неверно - ошибка. Соответствует 7 блоку
  (alert "Неверно заданы параметры" )
     (new_dialog "dd_param" dcl_id1)
  (set_tile "d1edit" on_d1)
  (set_tile "d2edit" on_d2)
  (set_tile "d3edit" on_d3)
  (set_tile "bd2edit" on_bd2)
  (set_tile "bd3edit" on_bd3)
  (set_tile "hedit" on_h)
  (set_tile "bhedit" on_bh)
  (set_tile "bedit" on_b)
  (set_tile "ttedit" on_tt)
  (set_tile "eedit" on_e)
  (set_tile "nedit" on_n)
)
   ( progn
	(setq flag1 nil)
	; рисование детали - запуск параметрического чертежа 
    ; все данные корректны. Соответствует 8 блоку графической схемы
        (DrawDetail d1 d2 d3 bd2 bd3 h bh tt b e n f_format)
 )   
)
 )
  ;ввод данных, необходимых для повторения всех действий
  ;соответствует 10 и 11 блокам графической схемы
 ( SETQ ans ( GETSTRING "\nПовторить<Д/Н>: " ) )
  ( SETQ flag ( OR ( = ans "Д" ) ( = ans "д" ) 
                   ( = ans "Y") ( = ans "y") ) )
 ); конец WHILE 
  ; выгрузка диалога из памяти
  (unload_dialog dcl_id1)
  ( PRIN1 )
  ;конец - 12 блок графической схемы алгоритма
) ;Аминь!
